﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WPF_Flex_DrawCellBorder
{    
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            c1Flexgrid1.CellFactory = new MyCellFactory();
        }
    }

    public class MyCellFactory : C1.WPF.FlexGrid.CellFactory
    {
        List<C1.WPF.FlexGrid.CellRange> crw = new List<C1.WPF.FlexGrid.CellRange>();
        public MyCellFactory()
        {
            crw.Add(new C1.WPF.FlexGrid.CellRange(0,0));
            crw.Add(new C1.WPF.FlexGrid.CellRange(1,1));
            crw.Add(new C1.WPF.FlexGrid.CellRange(2,2));
            crw.Add(new C1.WPF.FlexGrid.CellRange(3,3));        
        }
        public override Border CreateCellBorder(C1.WPF.FlexGrid.C1FlexGrid grid, C1.WPF.FlexGrid.CellType cellType, C1.WPF.FlexGrid.CellRange rng)
        {
            Border bdr = base.CreateCellBorder(grid, cellType, rng);

            if (cellType == C1.WPF.FlexGrid.CellType.Cell)
                if (crw.Contains(rng))
                {

                    VisualBrush vb = new VisualBrush();
                    vb.Visual = new Rectangle() { Height = 10, Width = 40, Stroke = new SolidColorBrush(Colors.Red), StrokeDashArray = new DoubleCollection() { 1.0 } };
                   
                    bdr.BorderThickness = new Thickness(2, 2, 2, 2);
                    bdr.BorderBrush = vb;                
                }

            return bdr;
        }

    }
}
